clang-tools 3.8.0

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
clang::tidy::modernize::ReplaceAutoPtrCheck Class Reference

Transforms the deprecated `std::auto_ptr` into the C++11 `std::unique_ptr`. More...

`#include <ReplaceAutoPtrCheck.h>`

Inheritance diagram for clang::tidy::modernize::ReplaceAutoPtrCheck:
[legend]
Collaboration diagram for clang::tidy::modernize::ReplaceAutoPtrCheck:
[legend]

## Public Member Functions
| ReplaceAutoPtrCheck (StringRef Name, ClangTidyContext *Context)
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register ASTMatchers with `Finder`. More...
void | registerPPCallbacks (CompilerInstance &Compiler) override
| Override this to register `PPCallbacks` with `Compiler`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Transforms the deprecated `std::auto_ptr` into the C++11 `std::unique_ptr`.

Note that both the `std::auto_ptr` type and the transfer of ownership are transformed. `std::auto_ptr` provides two ways to transfer the ownership, the copy-constructor and the assignment operator. Unlike most classes these operations do not 'copy' the resource but they 'steal' it. `std::unique_ptr` uses move semantics instead, which makes the intent of transferring the resource explicit. This difference between the two smart pointers requeres to wrap the copy-ctor and assign-operator with `std::move()`.

For example, given:

std::auto_ptr<int> i, j;
i = j;

This code is transformed to:

std::unique_ptr<in> i, j;
i = std::move(j);

Definition at line 44 of file ReplaceAutoPtrCheck.h.

## Constructor & Destructor Documentation

clang::tidy::modernize::ReplaceAutoPtrCheck::ReplaceAutoPtrCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 189 of file ReplaceAutoPtrCheck.cpp.

## Member Function Documentation

void clang::tidy::modernize::ReplaceAutoPtrCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 220 of file ReplaceAutoPtrCheck.cpp.

References clang::tidy::modernize::AutoPtrOwnershipTransferId, clang::tidy::modernize::AutoPtrTokenId, clang::tidy::modernize::checkTokenIsAutoPtr(), clang::tidy::ClangTidyCheck::diag(), clang::tidy::modernize::locateFromTypeLoc(), clang::tidy::modernize::locateFromUsingDecl(), Range, and SM.

void clang::tidy::modernize::ReplaceAutoPtrCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register ASTMatchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 199 of file ReplaceAutoPtrCheck.cpp.

References clang::tidy::ClangTidyCheck::getLangOpts(), clang::tidy::modernize::makeAutoPtrTypeLocMatcher(), clang::tidy::modernize::makeAutoPtrUsingDeclMatcher(), and clang::tidy::modernize::makeTransferOwnershipExprMatcher().

void clang::tidy::modernize::ReplaceAutoPtrCheck::registerPPCallbacks | ( | CompilerInstance & | Compiler | ) |
| override virtual

Override this to register `PPCallbacks` with `Compiler`.

This should be used for clang-tidy checks that analyze preprocessor- dependent properties, e.g. the order of include directives.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 209 of file ReplaceAutoPtrCheck.cpp.

References clang::tidy::ClangTidyCheck::getLangOpts().

void clang::tidy::modernize::ReplaceAutoPtrCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 195 of file ReplaceAutoPtrCheck.cpp.

References clang::tidy::ClangTidyCheck::Options, clang::tidy::OptionsView::store(), and clang::tidy::IncludeSorter::toString().

The documentation for this class was generated from the following files:

- ReplaceAutoPtrCheck.h
- ReplaceAutoPtrCheck.cpp